CustomerReadonlyProperties:
  type: object
  properties:
    id:
      type: integer
      description: Идентификатор покупателя
      example: 1
    avatar:
      nullable: true
      allOf:
        - type: object
        - $ref: '../../common_schemas.yaml#/File'
      description: Аватар клиента
CustomerFillableProperties:
  type: object
  properties:
    user_id:
      type: integer
      description: Идентификатор пользователя
      example: 42
    gender:
      type: integer
      description: Пол из CustomerGenderEnum
      example: 1
    comment_internal:
      type: string
      description: Внутренний комментарий о клиенте
      nullable: true
      example: "Важный клиент"
CustomerIncludes:
  type: object
  properties: 
    addresses:
      type: array
      items:
        $ref: './customer_addresses.yaml#/Address'
CustomerRequiredRequestProperties:
  type: object
  required:
    - user_id
    - gender
CustomerRequiredResponseProperties:
  type: object
  required:
    - id
    - user_id
    - gender
    - avatar
    - comment_internal
Customer:
  allOf:
    - $ref: '#/CustomerReadonlyProperties'
    - $ref: '#/CustomerFillableProperties'
    - $ref: '#/CustomerRequiredResponseProperties'
    - $ref: '#/CustomerIncludes'

CreateCustomerRequest:
  allOf:
    - $ref: '#/CustomerFillableProperties'
    - $ref: '#/CustomerRequiredRequestProperties'
ReplaceCustomerRequest:
  allOf:
    - $ref: '#/CustomerFillableProperties'
    - $ref: '#/CustomerRequiredRequestProperties'
PatchCustomerRequest:
  allOf:
    - $ref: '#/CustomerFillableProperties'
    - $ref: '#/CustomerRequiredRequestProperties'

SearchCustomersFilter:
  type: object

SearchCustomersRequest:
  type: object
  properties: 
    sort:
      $ref: '../../common_schemas.yaml#/RequestBodySort'
    filter: 
      $ref: '#/SearchCustomersFilter'
    include:
      $ref: '../../common_schemas.yaml#/RequestBodyInclude'
    pagination:
      $ref: '../../common_schemas.yaml#/RequestBodyPagination'

CustomerResponse:
  type: object
  properties:
    data:
      $ref: '#/Customer'
    meta:
      type: object
  required:
      - data
SearchCustomersResponse:
  type: object
  properties:
    data:
      type: array
      items:
        $ref: '#/Customer'
    meta:
      type: object
      properties: 
        pagination: 
          $ref: '../../common_schemas.yaml#/ResponseBodyPagination'
          
  required:
      - data
      - meta
